using MicroFour.StrataFrame.Business;
using MicroFour.StrataFrame.Security;
using MicroFour.StrataFrame.UI.Windows.Forms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.IO;

namespace StrataFlix.Business
{
    public partial class MovieItemsBO
    {

        #region " Component Implementation "

        [System.Diagnostics.DebuggerNonUserCodeAttribute()]
        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private System.ComponentModel.Container components = null;

        //NOTE: The following procedure is required by the Component Designer
        //It can be modified using the Component Designer.
        //Do not modify it using the code editor.
        [System.Diagnostics.DebuggerNonUserCodeAttribute()]
        private void InitializeComponent()
        {
            MicroFour.StrataFrame.Business.BusinessParentRelationship BusinessParentRelationship1 = new MicroFour.StrataFrame.Business.BusinessParentRelationship();
            //
            //MovieItemsBO
            //
            BusinessParentRelationship1.ForeignKeyField = new string[] { "mvi_mv_pk" };
            BusinessParentRelationship1.ParentBusinessObjectType = "StrataFlix.Business.MoviesBO";
            BusinessParentRelationship1.ParentPrimaryKeyField = new string[] { "mv_pk" };
            this.ParentRelationship = BusinessParentRelationship1;

        }

        #endregion


        #region BusinessLayer Overriden Methods & Properties

        /// <summary>
        /// The collection of required fields for the business object.
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override RequiredFieldsCollection RequiredFields
        {
            get
            {
                return base.RequiredFields;
            }
            set
            {
                base.RequiredFields = value;
            }
        }

        /// <summary>
        /// Defines the constraint that defines the parent-child relationship between this business object type and another business object type.
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override IBusinessParentRelationship ParentRelationship
        {
            get
            {
                return base.ParentRelationship;
            }
            set
            {
                base.ParentRelationship = value;
            }
        }

        /// <summary>
        /// Returns all of the field names in a single string in the form of [field1],[field2],...  This must be used in the place of '*' in select statements if Query Notifications are to be registered.
        /// </summary>
        protected override String AllFieldNames
        {
            get
            {
                return "[mvi_pk],[mvi_mv_pk],[mvi_Type],[mvi_ItemData],[mvi_CreatedAt],[mvi_CreatedBy],[mvi_Version]";
            }
        }

        /// <summary>
        /// The name of the database that contains the table to which this business object is mapped.
        /// </summary>
        public override String Database
        {
            get
            {
                return "StrataFlix";
            }
        }

        private static string[] _PrimaryKeyFields = new string[] { "mvi_pk" };
        /// <summary>
        /// Gets the field or fields that comprise the primary key for the business object.
        /// </summary>
        public override string[] PrimaryKeyFields
        {
            get
            {
                return _PrimaryKeyFields;
            }
        }

        /// <summary>
        /// The name of the table in the database to which this business object is mapped.
        /// </summary>
        public override String TableName
        {
            get
            {
                return "MovieItems";
            }
        }

        /// <summary>
        /// The schema of the table in the database to which this business object is mapped.
        /// </summary>
        public override String TableSchema
        {
            get
            {
                return "dbo";
            }
        }

        /// <summary>
        /// Creates and returns an array of DataColumns that contains the schema for the table.  This is used to prevent a round trip to the server to aquire the initial schema for the internal DataTable.
        /// </summary>
        protected override DataColumn[] CreateTableSchema()
        {
            return new DataColumn[] {
new DataColumn("mvi_pk", typeof(System.Int32)),
new DataColumn("mvi_mv_pk", typeof(System.Int32)),
new DataColumn("mvi_Type", typeof(System.Int32)),
new DataColumn("mvi_ItemData", typeof(System.Int32)),
new DataColumn("mvi_CreatedAt", typeof(System.DateTime)),
new DataColumn("mvi_CreatedBy", typeof(System.Int32)),
new DataColumn("mvi_Version", typeof(System.Int32))};
        }

        /// <summary>
        /// Adds a broken rule to the business object's collection
        /// </summary>
        protected void AddBrokenRule(MovieItemsBOFieldNames Field, string ErrorMessage)
        {
            base.AddBrokenRule(Field, ErrorMessage);
        }

        /// <summary>
        /// Adds a broken rule to the business object's collection
        /// </summary>
        protected new void AddBrokenRule(string FieldName, string ErrorMessage)
        {
            base.AddBrokenRule(FieldName, ErrorMessage);
        }

        /// <summary>
        /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
        /// </summary>
        protected void AddBrokenRuleByKey(MovieItemsBOFieldNames Field, string ErrorMessageKey)
        {
            base.AddBrokenRuleByKey(Field, ErrorMessageKey);
        }

        /// <summary>
        /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
        /// </summary>
        protected new void AddBrokenRuleByKey(string FieldName, string ErrorMessageKey)
        {
            base.AddBrokenRuleByKey(FieldName, ErrorMessageKey);
        }

        /// <summary>
        /// Gets a collection of the names for all fields that belong to this business object and map to the database.
        /// </summary>
        public override List<string> AllFieldsList
        {
            get
            {
                return _AllFieldsList;
            }
        }

        /// <summary>
        /// Gets a dictionary of the DbTypes for all fields that belong to this business object and map to the database.
        /// </summary>
        public override Dictionary<string, DbType> FieldDbTypes
        {
            get
            {
                return _FieldDbTypes;
            }
        }

        /// <summary>
        /// Gets a dictionary of all fields within this business object that map to the FieldNames enumeration for this business object.
        /// </summary>
        public override BusinessLayerFieldEnumDictionary FieldEnums
        {
            get
            {
                return _FieldEnums;
            }
        }

        /// <summary>
        /// Gets a dictionary of all of the lengths for all fields within this business object that map to a field in the database.
        /// </summary>
        public override Dictionary<string, int> FieldLengths
        {
            get
            {
                return _FieldLengths;
            }
        }

        /// <summary>
        /// Gets a dictionary of the native DbType (SqlDbType, OracleType, OleDbType, etc.) for all fields within this buisness object that map to a field in the database.
        /// </summary>
        public override Dictionary<string, int> FieldNativeDbTypes
        {
            get
            {
                return _FieldNativeDbTypes;
            }
        }

        /// <summary>
        /// Gets a dictionary of the security permission keys for each field in the business object.
        /// </summary>
        public override Dictionary<string, string> FieldPermissionKeys
        {
            get
            {
                return _FieldPermissionKeys;
            }
        }

        #endregion

        #region Field Properties

        /// <summary>
        /// Primary Key
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Primary Key"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 mvi_pk
        {
            get
            {
                return (System.Int32)this.CurrentRow["mvi_pk"];
            }
            set
            {
                this.CurrentRow["mvi_pk"] = value;
            }
        }

        /// <summary>
        /// Movie Foreign Key
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Movie Foreign Key"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 mvi_mv_pk
        {
            get
            {
                return (System.Int32)this.CurrentRow["mvi_mv_pk"];
            }
            set
            {
                this.CurrentRow["mvi_mv_pk"] = value;
            }
        }

        /// <summary>
        /// Record Type
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Record Type"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public MovieItemType mvi_Type
        {
            get
            {
                return (MovieItemType)this.CurrentRow["mvi_Type"];
            }
            set
            {
                this.CurrentRow["mvi_Type"] = value;
            }
        }

        /// <summary>
        /// Item type specific data
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Item type specific data"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 mvi_ItemData
        {
            get
            {
                return (System.Int32)this.CurrentRow["mvi_ItemData"];
            }
            set
            {
                this.CurrentRow["mvi_ItemData"] = value;
            }
        }

        /// <summary>
        /// Time Stamp
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Time Stamp"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.DateTime mvi_CreatedAt
        {
            get
            {
                return (System.DateTime)this.CurrentRow["mvi_CreatedAt"];
            }
            set
            {
                this.CurrentRow["mvi_CreatedAt"] = value;
            }
        }

        /// <summary>
        /// User Stamp
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("User Stamp"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 mvi_CreatedBy
        {
            get
            {
                return (System.Int32)this.CurrentRow["mvi_CreatedBy"];
            }
            set
            {
                this.CurrentRow["mvi_CreatedBy"] = value;
            }
        }

        /// <summary>
        /// Row Version
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Row Version"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 mvi_Version
        {
            get
            {
                return (System.Int32)this.CurrentRow["mvi_Version"];
            }
            set
            {
                this.CurrentRow["mvi_Version"] = value;
            }
        }

        #endregion

        #region Field Property Events

        #endregion

        #region Nested Types & Field Security

        /// <summary>
        /// Contains all of the field names that belong to the business object.
        /// </summary>
        public enum MovieItemsBOFieldNames
        {
            mvi_pk,
            mvi_mv_pk,
            mvi_Type,
            mvi_ItemData,
            mvi_CreatedAt,
            mvi_CreatedBy,
            mvi_Version,
            CUSTOM_FIELD
        }

        /// <summary>
        /// Gets the System.Type of the enumeration that contains the field names for the business object.
        /// </summary>
        public override System.Type GetFieldEnumType()
        {
            return typeof(MovieItemsBOFieldNames);
        }

        /// <summary>
        /// Creates a new CheckFieldSecurityEventArgs object that can be used with this business object type.
        /// </summary>
        protected override CheckFieldSecurityEventArgsBase CreateNewFieldSecurityEventArgs(System.Enum Field, string CustomField, string PermissionKey, PermissionInfo Perm)
        {
            return new CheckFieldSecurityEventArgs<MovieItemsBOFieldNames>(Field, CustomField, PermissionKey, Perm);
        }

        /// <summary>
        /// Describes a method that will handle the CheckFieldScurity event.
        /// </summary>
        public delegate void CheckFieldSecurityEventHandler(object sender, CheckFieldSecurityEventArgs<MovieItemsBOFieldNames> e);

        /// <summary>
        /// Occurs when the business objects needs to check the security on a field.
        /// </summary>
        public event CheckFieldSecurityEventHandler CheckFieldSecurity;

        /// <summary>
        /// Raises the CheckFieldSecurity event.
        /// </summary>
        protected override void OnCheckFieldSecurity(CheckFieldSecurityEventArgsBase e)
        {
            if (this.CheckFieldSecurity != null)
            {
                this.CheckFieldSecurity(this, (CheckFieldSecurityEventArgs<MovieItemsBOFieldNames>)e);
            }
        }

        #endregion

        #region Item Property Implementation


        private static List<string> _AllFieldsList;
        private static Dictionary<string, DbType> _FieldDbTypes;
        private static BusinessLayerFieldEnumDictionary _FieldEnums;
        private static Dictionary<string, int> _FieldLengths;
        private static Dictionary<string, int> _FieldNativeDbTypes;
        private static Dictionary<string, string> _FieldPermissionKeys;

        /// <summary>
        /// Initializes the static members of the MovieItemsBO class.
        /// </summary>
        static MovieItemsBO()
        {
            //-- Create the new shared dictionary and populate it with an 
            //   instance of each property descriptor
            _PropertyDescriptors = new PropertyDescriptorDictionary(12);
            _PropertyDescriptors.Add("mvi_pk", new FieldDescriptor(MovieItemsBOFieldNames.mvi_pk, typeof(System.Int32)));
            _PropertyDescriptors.Add("mvi_mv_pk", new FieldDescriptor(MovieItemsBOFieldNames.mvi_mv_pk, typeof(System.Int32)));
            _PropertyDescriptors.Add("mvi_Type", new FieldDescriptor(MovieItemsBOFieldNames.mvi_Type, typeof(MovieItemType)));
            _PropertyDescriptors.Add("mvi_ItemData", new FieldDescriptor(MovieItemsBOFieldNames.mvi_ItemData, typeof(System.Int32)));
            _PropertyDescriptors.Add("mvi_CreatedAt", new FieldDescriptor(MovieItemsBOFieldNames.mvi_CreatedAt, typeof(System.DateTime)));
            _PropertyDescriptors.Add("mvi_CreatedBy", new FieldDescriptor(MovieItemsBOFieldNames.mvi_CreatedBy, typeof(System.Int32)));
            _PropertyDescriptors.Add("mvi_Version", new FieldDescriptor(MovieItemsBOFieldNames.mvi_Version, typeof(System.Int32)));

            _AllFieldsList = new List<string>(7);
            _AllFieldsList.Add("mvi_pk");
            _AllFieldsList.Add("mvi_mv_pk");
            _AllFieldsList.Add("mvi_Type");
            _AllFieldsList.Add("mvi_ItemData");
            _AllFieldsList.Add("mvi_CreatedAt");
            _AllFieldsList.Add("mvi_CreatedBy");
            _AllFieldsList.Add("mvi_Version");

            _FieldDbTypes = new Dictionary<string, DbType>(7);
            _FieldDbTypes.Add("mvi_pk", DbType.Int32);
            _FieldDbTypes.Add("mvi_mv_pk", DbType.Int32);
            _FieldDbTypes.Add("mvi_Type", DbType.Int32);
            _FieldDbTypes.Add("mvi_ItemData", DbType.Int32);
            _FieldDbTypes.Add("mvi_CreatedAt", DbType.DateTime);
            _FieldDbTypes.Add("mvi_CreatedBy", DbType.Int32);
            _FieldDbTypes.Add("mvi_Version", DbType.Int32);

            _FieldEnums = new BusinessLayerFieldEnumDictionary(8);
            _FieldEnums.Add("mvi_pk", MovieItemsBOFieldNames.mvi_pk);
            _FieldEnums.Add("mvi_mv_pk", MovieItemsBOFieldNames.mvi_mv_pk);
            _FieldEnums.Add("mvi_Type", MovieItemsBOFieldNames.mvi_Type);
            _FieldEnums.Add("mvi_ItemData", MovieItemsBOFieldNames.mvi_ItemData);
            _FieldEnums.Add("mvi_CreatedAt", MovieItemsBOFieldNames.mvi_CreatedAt);
            _FieldEnums.Add("mvi_CreatedBy", MovieItemsBOFieldNames.mvi_CreatedBy);
            _FieldEnums.Add("mvi_Version", MovieItemsBOFieldNames.mvi_Version);
            _FieldEnums.Add("CUSTOM_FIELD", MovieItemsBOFieldNames.CUSTOM_FIELD);

            _FieldLengths = new Dictionary<string, int>(7);
            _FieldLengths.Add("mvi_pk", 4);
            _FieldLengths.Add("mvi_mv_pk", 4);
            _FieldLengths.Add("mvi_Type", 4);
            _FieldLengths.Add("mvi_ItemData", 4);
            _FieldLengths.Add("mvi_CreatedAt", 8);
            _FieldLengths.Add("mvi_CreatedBy", 4);
            _FieldLengths.Add("mvi_Version", 4);

            _FieldNativeDbTypes = new Dictionary<string, int>(7);
            _FieldNativeDbTypes.Add("mvi_pk", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("mvi_mv_pk", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("mvi_Type", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("mvi_ItemData", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("mvi_CreatedAt", (int)System.Data.SqlDbType.DateTime);
            _FieldNativeDbTypes.Add("mvi_CreatedBy", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("mvi_Version", (int)System.Data.SqlDbType.Int);

            _FieldPermissionKeys = new Dictionary<string, string>(7);

        }

        private static bool _AreCustomDescriptorsEvaluated = false;
        protected override bool AreCustomDescriptorsEvaluated
        {
            get
            {
                bool llReturn = _AreCustomDescriptorsEvaluated;
                _AreCustomDescriptorsEvaluated = true;
                return llReturn;
            }
        }

        private static PropertyDescriptorDictionary _PropertyDescriptors;
        protected override PropertyDescriptorDictionary PropertyDescriptors
        {
            get
            {
                return _PropertyDescriptors;
            }
        }

        /// <summary>
        /// A PropertyDescriptor class used to Get and Set the value of fields within the MovieItemsBO business object.
        /// </summary>
        private class FieldDescriptor :
        MicroFour.StrataFrame.Business.FieldPropertyDescriptor<MovieItemsBOFieldNames>
        {
            public FieldDescriptor(MovieItemsBOFieldNames field, Type fieldType) :
                base(field, fieldType) { }
            private static Type _ComponentType = typeof(MovieItemsBO);
            public override object GetValue(object component)
            {
                switch (this.Field)
                {
                    case MovieItemsBOFieldNames.mvi_pk:
                        return ((MovieItemsBO)component).mvi_pk;
                    case MovieItemsBOFieldNames.mvi_mv_pk:
                        return ((MovieItemsBO)component).mvi_mv_pk;
                    case MovieItemsBOFieldNames.mvi_Type:
                        return ((MovieItemsBO)component).mvi_Type;
                    case MovieItemsBOFieldNames.mvi_ItemData:
                        return ((MovieItemsBO)component).mvi_ItemData;
                    case MovieItemsBOFieldNames.mvi_CreatedAt:
                        return ((MovieItemsBO)component).mvi_CreatedAt;
                    case MovieItemsBOFieldNames.mvi_CreatedBy:
                        return ((MovieItemsBO)component).mvi_CreatedBy;
                    case MovieItemsBOFieldNames.mvi_Version:
                        return ((MovieItemsBO)component).mvi_Version;
                    default:
                        throw new BusinessLayerException("Field not supported.");
                }
            }
            public override void SetValue(object component, object value)
            {
                switch (this.Field)
                {
                    case MovieItemsBOFieldNames.mvi_pk:
                        ((MovieItemsBO)component).mvi_pk = (System.Int32)value;
                        break;
                    case MovieItemsBOFieldNames.mvi_mv_pk:
                        ((MovieItemsBO)component).mvi_mv_pk = (System.Int32)value;
                        break;
                    case MovieItemsBOFieldNames.mvi_Type:
                        ((MovieItemsBO)component).mvi_Type = (MovieItemType)value;
                        break;
                    case MovieItemsBOFieldNames.mvi_ItemData:
                        ((MovieItemsBO)component).mvi_ItemData = (System.Int32)value;
                        break;
                    case MovieItemsBOFieldNames.mvi_CreatedAt:
                        ((MovieItemsBO)component).mvi_CreatedAt = (System.DateTime)value;
                        break;
                    case MovieItemsBOFieldNames.mvi_CreatedBy:
                        ((MovieItemsBO)component).mvi_CreatedBy = (System.Int32)value;
                        break;
                    case MovieItemsBOFieldNames.mvi_Version:
                        ((MovieItemsBO)component).mvi_Version = (System.Int32)value;
                        break;
                    default:
                        throw new BusinessLayerException("Field not supported.");
                }
            }
            public override Type ComponentType
            {
                get
                {
                    return _ComponentType;
                }
            }
        }

        #endregion

    }

}
