using MicroFour.StrataFrame.Business;
using MicroFour.StrataFrame.Security;
using MicroFour.StrataFrame.UI.Windows.Forms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.IO;

namespace StrataFlix.Business
{
    public partial class ProductPricingBO
    {

        #region " Component Implementation "

        [System.Diagnostics.DebuggerNonUserCodeAttribute()]
        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private System.ComponentModel.Container components = null;

        //NOTE: The following procedure is required by the Component Designer
        //It can be modified using the Component Designer.
        //Do not modify it using the code editor.
        [System.Diagnostics.DebuggerNonUserCodeAttribute()]
        private void InitializeComponent()
        {
            MicroFour.StrataFrame.Business.BusinessParentRelationship BusinessParentRelationship1 = new MicroFour.StrataFrame.Business.BusinessParentRelationship();
            //
            //ProductPricingBO
            //
            BusinessParentRelationship1.ForeignKeyField = new string[] { "pp_mv_pk" };
            BusinessParentRelationship1.ParentBusinessObjectType = "StrataFlix.Business.MoviesBO";
            BusinessParentRelationship1.ParentPrimaryKeyField = new string[] { "mv_pk" };
            this.ParentRelationship = BusinessParentRelationship1;
            this.PrimaryKeyIsAutoIncremented = false;
            this.PrimaryKeyIsUpdatable = true;

        }

        #endregion


        #region BusinessLayer Overriden Methods & Properties

        /// <summary>
        /// The collection of required fields for the business object.
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override RequiredFieldsCollection RequiredFields
        {
            get
            {
                return base.RequiredFields;
            }
            set
            {
                base.RequiredFields = value;
            }
        }

        /// <summary>
        /// Defines the constraint that defines the parent-child relationship between this business object type and another business object type.
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override IBusinessParentRelationship ParentRelationship
        {
            get
            {
                return base.ParentRelationship;
            }
            set
            {
                base.ParentRelationship = value;
            }
        }

        /// <summary>
        /// Returns all of the field names in a single string in the form of [field1],[field2],...  This must be used in the place of '*' in select statements if Query Notifications are to be registered.
        /// </summary>
        protected override String AllFieldNames
        {
            get
            {
                return "[pp_pk],[pp_mv_pk],[pp_Price],[pp_CreatedAt],[pp_CreatedBy],[pp_Version]";
            }
        }

        /// <summary>
        /// The name of the database that contains the table to which this business object is mapped.
        /// </summary>
        public override String Database
        {
            get
            {
                return "StrataFlix";
            }
        }

        private static string[] _PrimaryKeyFields = new string[] { "pp_pk" };
        /// <summary>
        /// Gets the field or fields that comprise the primary key for the business object.
        /// </summary>
        public override string[] PrimaryKeyFields
        {
            get
            {
                return _PrimaryKeyFields;
            }
        }

        /// <summary>
        /// The name of the table in the database to which this business object is mapped.
        /// </summary>
        public override String TableName
        {
            get
            {
                return "ProductPricing";
            }
        }

        /// <summary>
        /// The schema of the table in the database to which this business object is mapped.
        /// </summary>
        public override String TableSchema
        {
            get
            {
                return "dbo";
            }
        }

        /// <summary>
        /// Creates and returns an array of DataColumns that contains the schema for the table.  This is used to prevent a round trip to the server to aquire the initial schema for the internal DataTable.
        /// </summary>
        protected override DataColumn[] CreateTableSchema()
        {
            return new DataColumn[] {
new DataColumn("pp_pk", typeof(System.Guid)),
new DataColumn("pp_mv_pk", typeof(System.Int32)),
new DataColumn("pp_Price", typeof(System.Decimal)),
new DataColumn("pp_CreatedAt", typeof(System.DateTime)),
new DataColumn("pp_CreatedBy", typeof(System.Int32)),
new DataColumn("pp_Version", typeof(System.Int32))};
        }

        /// <summary>
        /// Adds a broken rule to the business object's collection
        /// </summary>
        protected void AddBrokenRule(ProductPricingBOFieldNames Field, string ErrorMessage)
        {
            base.AddBrokenRule(Field, ErrorMessage);
        }

        /// <summary>
        /// Adds a broken rule to the business object's collection
        /// </summary>
        protected new void AddBrokenRule(string FieldName, string ErrorMessage)
        {
            base.AddBrokenRule(FieldName, ErrorMessage);
        }

        /// <summary>
        /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
        /// </summary>
        protected void AddBrokenRuleByKey(ProductPricingBOFieldNames Field, string ErrorMessageKey)
        {
            base.AddBrokenRuleByKey(Field, ErrorMessageKey);
        }

        /// <summary>
        /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
        /// </summary>
        protected new void AddBrokenRuleByKey(string FieldName, string ErrorMessageKey)
        {
            base.AddBrokenRuleByKey(FieldName, ErrorMessageKey);
        }

        /// <summary>
        /// Gets a collection of the names for all fields that belong to this business object and map to the database.
        /// </summary>
        public override List<string> AllFieldsList
        {
            get
            {
                return _AllFieldsList;
            }
        }

        /// <summary>
        /// Gets a dictionary of the DbTypes for all fields that belong to this business object and map to the database.
        /// </summary>
        public override Dictionary<string, DbType> FieldDbTypes
        {
            get
            {
                return _FieldDbTypes;
            }
        }

        /// <summary>
        /// Gets a dictionary of all fields within this business object that map to the FieldNames enumeration for this business object.
        /// </summary>
        public override BusinessLayerFieldEnumDictionary FieldEnums
        {
            get
            {
                return _FieldEnums;
            }
        }

        /// <summary>
        /// Gets a dictionary of all of the lengths for all fields within this business object that map to a field in the database.
        /// </summary>
        public override Dictionary<string, int> FieldLengths
        {
            get
            {
                return _FieldLengths;
            }
        }

        /// <summary>
        /// Gets a dictionary of the native DbType (SqlDbType, OracleType, OleDbType, etc.) for all fields within this buisness object that map to a field in the database.
        /// </summary>
        public override Dictionary<string, int> FieldNativeDbTypes
        {
            get
            {
                return _FieldNativeDbTypes;
            }
        }

        /// <summary>
        /// Gets a dictionary of the security permission keys for each field in the business object.
        /// </summary>
        public override Dictionary<string, string> FieldPermissionKeys
        {
            get
            {
                return _FieldPermissionKeys;
            }
        }

        #endregion

        #region Field Properties

        /// <summary>
        /// Primary Key
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Primary Key"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Guid pp_pk
        {
            get
            {
                return (System.Guid)this.CurrentRow["pp_pk"];
            }
            set
            {
                this.CurrentRow["pp_pk"] = value;
            }
        }

        /// <summary>
        /// Movie Foreign Key
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Movie Foreign Key"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 pp_mv_pk
        {
            get
            {
                return (System.Int32)this.CurrentRow["pp_mv_pk"];
            }
            set
            {
                this.CurrentRow["pp_mv_pk"] = value;
            }
        }

        /// <summary>
        /// Product price
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Product price"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Decimal pp_Price
        {
            get
            {
                return (System.Decimal)this.CurrentRow["pp_Price"];
            }
            set
            {
                this.CurrentRow["pp_Price"] = value;
            }
        }

        /// <summary>
        /// Time Stamp
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Time Stamp"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.DateTime pp_CreatedAt
        {
            get
            {
                return (System.DateTime)this.CurrentRow["pp_CreatedAt"];
            }
            set
            {
                this.CurrentRow["pp_CreatedAt"] = value;
            }
        }

        /// <summary>
        /// User Stamp
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("User Stamp"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 pp_CreatedBy
        {
            get
            {
                return (System.Int32)this.CurrentRow["pp_CreatedBy"];
            }
            set
            {
                this.CurrentRow["pp_CreatedBy"] = value;
            }
        }

        /// <summary>
        /// Row Version
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Row Version"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 pp_Version
        {
            get
            {
                return (System.Int32)this.CurrentRow["pp_Version"];
            }
            set
            {
                this.CurrentRow["pp_Version"] = value;
            }
        }

        #endregion

        #region Field Property Events

        #endregion

        #region Nested Types & Field Security

        /// <summary>
        /// Contains all of the field names that belong to the business object.
        /// </summary>
        public enum ProductPricingBOFieldNames
        {
            pp_pk,
            pp_mv_pk,
            pp_Price,
            pp_CreatedAt,
            pp_CreatedBy,
            pp_Version,
            CUSTOM_FIELD
        }

        /// <summary>
        /// Gets the System.Type of the enumeration that contains the field names for the business object.
        /// </summary>
        public override System.Type GetFieldEnumType()
        {
            return typeof(ProductPricingBOFieldNames);
        }

        /// <summary>
        /// Creates a new CheckFieldSecurityEventArgs object that can be used with this business object type.
        /// </summary>
        protected override CheckFieldSecurityEventArgsBase CreateNewFieldSecurityEventArgs(System.Enum Field, string CustomField, string PermissionKey, PermissionInfo Perm)
        {
            return new CheckFieldSecurityEventArgs<ProductPricingBOFieldNames>(Field, CustomField, PermissionKey, Perm);
        }

        /// <summary>
        /// Describes a method that will handle the CheckFieldScurity event.
        /// </summary>
        public delegate void CheckFieldSecurityEventHandler(object sender, CheckFieldSecurityEventArgs<ProductPricingBOFieldNames> e);

        /// <summary>
        /// Occurs when the business objects needs to check the security on a field.
        /// </summary>
        public event CheckFieldSecurityEventHandler CheckFieldSecurity;

        /// <summary>
        /// Raises the CheckFieldSecurity event.
        /// </summary>
        protected override void OnCheckFieldSecurity(CheckFieldSecurityEventArgsBase e)
        {
            if (this.CheckFieldSecurity != null)
            {
                this.CheckFieldSecurity(this, (CheckFieldSecurityEventArgs<ProductPricingBOFieldNames>)e);
            }
        }

        #endregion

        #region Item Property Implementation


        private static List<string> _AllFieldsList;
        private static Dictionary<string, DbType> _FieldDbTypes;
        private static BusinessLayerFieldEnumDictionary _FieldEnums;
        private static Dictionary<string, int> _FieldLengths;
        private static Dictionary<string, int> _FieldNativeDbTypes;
        private static Dictionary<string, string> _FieldPermissionKeys;

        /// <summary>
        /// Initializes the static members of the ProductPricingBO class.
        /// </summary>
        static ProductPricingBO()
        {
            //-- Create the new shared dictionary and populate it with an 
            //   instance of each property descriptor
            _PropertyDescriptors = new PropertyDescriptorDictionary(11);
            _PropertyDescriptors.Add("pp_pk", new FieldDescriptor(ProductPricingBOFieldNames.pp_pk, typeof(System.Guid)));
            _PropertyDescriptors.Add("pp_mv_pk", new FieldDescriptor(ProductPricingBOFieldNames.pp_mv_pk, typeof(System.Int32)));
            _PropertyDescriptors.Add("pp_Price", new FieldDescriptor(ProductPricingBOFieldNames.pp_Price, typeof(System.Decimal)));
            _PropertyDescriptors.Add("pp_CreatedAt", new FieldDescriptor(ProductPricingBOFieldNames.pp_CreatedAt, typeof(System.DateTime)));
            _PropertyDescriptors.Add("pp_CreatedBy", new FieldDescriptor(ProductPricingBOFieldNames.pp_CreatedBy, typeof(System.Int32)));
            _PropertyDescriptors.Add("pp_Version", new FieldDescriptor(ProductPricingBOFieldNames.pp_Version, typeof(System.Int32)));

            _AllFieldsList = new List<string>(6);
            _AllFieldsList.Add("pp_pk");
            _AllFieldsList.Add("pp_mv_pk");
            _AllFieldsList.Add("pp_Price");
            _AllFieldsList.Add("pp_CreatedAt");
            _AllFieldsList.Add("pp_CreatedBy");
            _AllFieldsList.Add("pp_Version");

            _FieldDbTypes = new Dictionary<string, DbType>(6);
            _FieldDbTypes.Add("pp_pk", DbType.Guid);
            _FieldDbTypes.Add("pp_mv_pk", DbType.Int32);
            _FieldDbTypes.Add("pp_Price", DbType.Currency);
            _FieldDbTypes.Add("pp_CreatedAt", DbType.DateTime);
            _FieldDbTypes.Add("pp_CreatedBy", DbType.Int32);
            _FieldDbTypes.Add("pp_Version", DbType.Int32);

            _FieldEnums = new BusinessLayerFieldEnumDictionary(7);
            _FieldEnums.Add("pp_pk", ProductPricingBOFieldNames.pp_pk);
            _FieldEnums.Add("pp_mv_pk", ProductPricingBOFieldNames.pp_mv_pk);
            _FieldEnums.Add("pp_Price", ProductPricingBOFieldNames.pp_Price);
            _FieldEnums.Add("pp_CreatedAt", ProductPricingBOFieldNames.pp_CreatedAt);
            _FieldEnums.Add("pp_CreatedBy", ProductPricingBOFieldNames.pp_CreatedBy);
            _FieldEnums.Add("pp_Version", ProductPricingBOFieldNames.pp_Version);
            _FieldEnums.Add("CUSTOM_FIELD", ProductPricingBOFieldNames.CUSTOM_FIELD);

            _FieldLengths = new Dictionary<string, int>(6);
            _FieldLengths.Add("pp_pk", 16);
            _FieldLengths.Add("pp_mv_pk", 4);
            _FieldLengths.Add("pp_Price", 8);
            _FieldLengths.Add("pp_CreatedAt", 8);
            _FieldLengths.Add("pp_CreatedBy", 4);
            _FieldLengths.Add("pp_Version", 4);

            _FieldNativeDbTypes = new Dictionary<string, int>(6);
            _FieldNativeDbTypes.Add("pp_pk", (int)System.Data.SqlDbType.UniqueIdentifier);
            _FieldNativeDbTypes.Add("pp_mv_pk", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("pp_Price", (int)System.Data.SqlDbType.Money);
            _FieldNativeDbTypes.Add("pp_CreatedAt", (int)System.Data.SqlDbType.DateTime);
            _FieldNativeDbTypes.Add("pp_CreatedBy", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("pp_Version", (int)System.Data.SqlDbType.Int);

            _FieldPermissionKeys = new Dictionary<string, string>(6);

        }

        private static bool _AreCustomDescriptorsEvaluated = false;
        protected override bool AreCustomDescriptorsEvaluated
        {
            get
            {
                bool llReturn = _AreCustomDescriptorsEvaluated;
                _AreCustomDescriptorsEvaluated = true;
                return llReturn;
            }
        }

        private static PropertyDescriptorDictionary _PropertyDescriptors;
        protected override PropertyDescriptorDictionary PropertyDescriptors
        {
            get
            {
                return _PropertyDescriptors;
            }
        }

        /// <summary>
        /// A PropertyDescriptor class used to Get and Set the value of fields within the ProductPricingBO business object.
        /// </summary>
        private class FieldDescriptor :
        MicroFour.StrataFrame.Business.FieldPropertyDescriptor<ProductPricingBOFieldNames>
        {
            public FieldDescriptor(ProductPricingBOFieldNames field, Type fieldType) :
                base(field, fieldType) { }
            private static Type _ComponentType = typeof(ProductPricingBO);
            public override object GetValue(object component)
            {
                switch (this.Field)
                {
                    case ProductPricingBOFieldNames.pp_pk:
                        return ((ProductPricingBO)component).pp_pk;
                    case ProductPricingBOFieldNames.pp_mv_pk:
                        return ((ProductPricingBO)component).pp_mv_pk;
                    case ProductPricingBOFieldNames.pp_Price:
                        return ((ProductPricingBO)component).pp_Price;
                    case ProductPricingBOFieldNames.pp_CreatedAt:
                        return ((ProductPricingBO)component).pp_CreatedAt;
                    case ProductPricingBOFieldNames.pp_CreatedBy:
                        return ((ProductPricingBO)component).pp_CreatedBy;
                    case ProductPricingBOFieldNames.pp_Version:
                        return ((ProductPricingBO)component).pp_Version;
                    default:
                        throw new BusinessLayerException("Field not supported.");
                }
            }
            public override void SetValue(object component, object value)
            {
                switch (this.Field)
                {
                    case ProductPricingBOFieldNames.pp_pk:
                        ((ProductPricingBO)component).pp_pk = (System.Guid)value;
                        break;
                    case ProductPricingBOFieldNames.pp_mv_pk:
                        ((ProductPricingBO)component).pp_mv_pk = (System.Int32)value;
                        break;
                    case ProductPricingBOFieldNames.pp_Price:
                        ((ProductPricingBO)component).pp_Price = (System.Decimal)value;
                        break;
                    case ProductPricingBOFieldNames.pp_CreatedAt:
                        ((ProductPricingBO)component).pp_CreatedAt = (System.DateTime)value;
                        break;
                    case ProductPricingBOFieldNames.pp_CreatedBy:
                        ((ProductPricingBO)component).pp_CreatedBy = (System.Int32)value;
                        break;
                    case ProductPricingBOFieldNames.pp_Version:
                        ((ProductPricingBO)component).pp_Version = (System.Int32)value;
                        break;
                    default:
                        throw new BusinessLayerException("Field not supported.");
                }
            }
            public override Type ComponentType
            {
                get
                {
                    return _ComponentType;
                }
            }
        }

        #endregion

    }

}
